#include <YSI_Coding\y_hooks>
#define MAX_PRICEPD 100
#define MAX_MAKANAN_NAMA 32

// Enum untuk indeks menu
enum PedagangMenu
{
    mId,
    mPrice
};

// Array untuk menyimpan data menu
new MenuP[MAX_PRICEPD][PedagangMenu];
new Makanan[MAX_PRICEPD][MAX_MAKANAN_NAMA]; // Array terpisah untuk menyimpan nama makanan
new TotalMakanan;

// Fungsi untuk memuat data menu makanan dari database
function LoadMenuMakanan()
{
    new query[128];
    mysql_format(g_SQL, query, sizeof(query), "SELECT id, makanan, harga FROM menu_pedagang");
    mysql_tquery(g_SQL, query, "OnMenuMakananLoaded"); // Memanggil query dan callback
}

// Forward deklarasi untuk callback OnMenuMakananLoaded
forward OnMenuMakananLoaded();
public OnMenuMakananLoaded()
{
    new id, makanan[MAX_MAKANAN_NAMA], harga;
    TotalMakanan = 0;

    // Mendapatkan jumlah baris dari cache
    new rows;
    cache_get_row_count(rows);
    
    for (new i = 0; i < rows && i < MAX_PRICEPD; i++)
    {
        // Mendapatkan nilai dari cache
        cache_get_value_name_int(i, "id", id);
        cache_get_value_name(i, "makanan", makanan, sizeof(makanan));
        cache_get_value_name_int(i, "harga", harga);

        // Memasukkan data ke dalam array
        MenuP[TotalMakanan][mId] = id;
        strcpy(Makanan[TotalMakanan], makanan); // Menyalin nama makanan
        MenuP[TotalMakanan][mPrice] = harga;

        TotalMakanan++;
    }
}

// Fungsi untuk menampilkan daftar makanan dalam bentuk dialog ke player
function ListMakanan(playerid)
{
    new String[512];
    format(String, sizeof(String), "Daftar Menu Makanan:\n"); // Memastikan string diinisialisasi

    // Loop untuk menyusun data menu makanan
    for (new i = 0; i < TotalMakanan; i++)
    {
        new Line[64];
        format(Line, sizeof(Line), "%s - Rp%d\n", Makanan[i], MenuP[i][mPrice]);
        strcat(String, Line);
    }

    // Menampilkan dialog ke pemain
    ShowPlayerDialog(playerid, DIALOG_UNUSED, DIALOG_STYLE_MSGBOX, "Menu Makanan", String, "OK", "");
}

// Fungsi untuk menambahkan makanan dan harganya
CMD:pricemakan(playerid, params[])
{
    new makanan[MAX_MAKANAN_NAMA], hargaString[10];

    // Memastikan input memiliki format yang benar
    if (sscanf(params, "s d", makanan, hargaString))
    {
        new harga = strval(hargaString);

        // Memeriksa jika harga valid
        if (harga <= 0)
        {
            SendClientMessage(playerid, COLOR_RED, "Harga harus lebih besar dari 0.");
            return 1; // Menghentikan eksekusi
        }

        // Menyimpan data ke dalam database
        new query[128];
        format(query, sizeof(query), "INSERT INTO menu_pedagang (makanan, harga) VALUES ('%s', %d)", makanan, harga);
        mysql_query(g_SQL, query);

        SendClientMessage(playerid, COLOR_GREEN, "Makanan berhasil ditambahkan!");

        // Memuat ulang menu makanan setelah penambahan
        LoadMenuMakanan();
        
        return 1; // Menghentikan eksekusi
    }
    else
    {
        SendClientMessage(playerid, COLOR_YELLOW, "Penggunaan: /pricemakan <nama_makanan> <harga>");
        return 1; // Menghentikan eksekusi
    }
}
// Fungsi untuk melihat semua harga makanan
CMD:lihatharga(playerid, params[])
{
    // Pastikan data menu makanan sudah dimuat
    if (TotalMakanan == 0)
    {
        SendClientMessage(playerid, COLOR_RED, "Menu makanan belum dimuat. Silakan coba lagi.");
        return 1; // Menghentikan eksekusi
    }

    // Memanggil fungsi ListMakanan untuk menampilkan daftar makanan
    ListMakanan(playerid);
    return 1; // Menghentikan eksekusi
}