//Enums
#define MAX_ASKS (50)

enum askData {
    bool:askExists,
    askType,
    askPlayer,
    askQuestion[128 char]
};
new AskData[MAX_ASKS][askData];

Ask_GetCount(playerid) {
    new count = 0;

    for (new i = 0; i < MAX_ASK; i++) if (AskData[i][askExists] && AskData[i][askPlayer] == playerid) {
        count++;
    }
    return count;
}

Ask_Count() {
    new count = 0;

    for (new i = 0; i != MAX_ASK; i ++) if(AskData[i][askExists]) {
        count++;
    }
    return count;
}

Ask_Clear(playerid) {
    for (new i = 0; i < MAX_ASK; i++) if (AskData[i][askExists] && AskData[i][askPlayer] == playerid) {
        Ask_Remove(i);
    }
    return 1;
}

Ask_Add(playerid, const text[])
{
    for (new i = 0; i != MAX_ASK; i ++)
    {
        if(!AskData[i][askExists])
        {
            AskData[i][askExists] = true;
            AskData[i][askPlayer] = playerid;

            strpack(AskData[i][askQuestion], text, 128 char);
            return i;
        }
    }
    return -1;
}

Ask_Remove(askid)
{
    if(askid != -1 && AskData[askid][askExists])
    {
        AskData[askid][askExists] = false;
        AskData[askid][askPlayer] = INVALID_PLAYER_ID;
    }
    return 1;
}

/*CMD:ask(playerid, params[])
{
    new reportid = -1;
		
    if(isnull(params))
    {
        SyntaxMsg(playerid, "/ask [question]");
        //Info(playerid, "```\nGunakan ini untuk bertanya.```");
        return 1;
    }
    if(Ask_GetCount(playerid) > 1)
        return ErrorMsg(playerid, "Kamu sudah memiliki 1 Pertanyaan!");

    if(pData[playerid][pAskTime] >= gettime())
        return Error(playerid, "Mohon tunggu %d detik untuk mengajukan pertanyaan.", pData[playerid][pAskTime] - gettime());

    if((reportid = Ask_Add(playerid, params)) != -1)
    {
        Servers(playerid, "YOUR QUESTION: {DDA0DD}%s", params);
        SendStaffMessage(COLOR_RED, "{DDA0DD}[ASK: #%d] "WHITE_E"%s (ID: %d)", reportid, pData[playerid][pName], playerid);
        SendStaffMessage(COLOR_RED, "QUESTION: %s", params);
        pData[playerid][pAskTime] = gettime() + 30;
    }
    else ErrorMsg(playerid, "Pertanyaan sedang penuh!");
    return 1;
}

CMD:aask(playerid, params[])
{
    if(pData[playerid][pAdmin] < 1)
   		if(pData[playerid][pHelper] == 0)
     		return ErrorMsg(playerid, "```\nKamu tidak memiliki hak untuk menggunakan ini!```");

    new reportid, msg[32];
    if(sscanf(params,"ds[32]", reportid, msg))
        return SyntaxMsg(playerid, "```\n/aask [ask id] [jawaban] (/asks for a list)```");

    if((reportid < 0 || reportid >= MAX_ASKS) || !AskData[reportid][askExists])
        return Error(playerid, "```\nID Ask tidak valid, Listitem dari 0 sampai %d.```", MAX_ASKS);

    SendStaffMessage(COLOR_RED, "```\n{DDA0DD}%s telah menjawab pertanyaan %s(%d).```", pData[playerid][pAdminname], pData[AskData[reportid][askPlayer]][pName], AskData[reportid][askPlayer]);
    Servers(AskData[reportid][askPlayer], "ANSWER: {FF0000}%s {FFFFFF}: %s.", pData[playerid][pAdminname], msg);

    Ask_Remove(reportid);
    return 1;
}


CMD:asks(playerid, params[])
{
    if(pData[playerid][pAdmin] < 1)
   		if(pData[playerid][pHelper] == 0)
     		return PermissionError(playerid);
			
	new gstr[1024], mstr[128], lstr[512];
    strcat(gstr,"ID\tASKer\tPertanyaan \n",sizeof(gstr));

    for (new i = 0; i != MAX_ASKS; i ++)
    {
        if(!AskData[i][askExists])
           return ErrorMsg(playerid, "Tidak ada Pertanyaan yang aktif.");
       
        strunpack(mstr, AskData[i][askText]);

        if(strlen(mstr) > 32)
            format(lstr,sizeof(lstr), "#%d\t%s (%d)\t%.32s ...\n", i, pData[AskData[i][askPlayer]][pName], AskData[i][askPlayer], mstr);
        else
            format(lstr,sizeof(lstr), "#%d\t%s (%d)\t%s\n", i, pData[AskData[i][askPlayer]][pName], AskData[i][askPlayer], mstr);

        strcat(gstr,lstr,sizeof(gstr));
        ShowPlayerDialog(playerid, DIALOG_ASKS, DIALOG_STYLE_TABLIST_HEADERS,"Ask's",gstr,"Next","Cancel");
    }
    return 1;
}

CMD:clearask(playerid, params[])
{
    if(pData[playerid][pAdmin] < 3)
            return PermissionError(playerid);
    new
        count;

    for (new i = 0; i != MAX_ASKS; i ++)
    {
        if(AskData[i][askExists]) {
            Ask_Remove(i);
            count++;
        }
    }
    if(!count)
        return ErrorMsg(playerid, "Tidak ada Pertanyaan yang aktif.");
            
    SendStaffMessage(COLOR_RED, "%s has removed all asks on the server.", pData[playerid][pAdminname]);
    return 1;
}*/
CMD:ask(playerid, params[])
{
    if(isnull(params))
        return SendSyntaxMessage(playerid, "/ask [questions]");

	if (!PlayerData[playerid][pLogged]) return ErrorMsg(playerid, "Kamu belum login.");

    if(PlayerData[playerid][pAsk] || Ask_GetCount(playerid) > 0)
        return ErrorMsg(playerid, "Menunggu dijawab dari admin untuk mengulangi pertanyaan Kamu lagi..");

    new askid = -1;
    if((askid = Ask_Add(playerid, params)) != -1)
    {
        SendQuestionMessage(COLOR_LENZ, sprintf("[ASK:#%d] "YELLOW"%s (%d): %s", askid, ReturnName(playerid), playerid, params));
        PlayerData[playerid][pAsk] = true;
        format(PlayerData[playerid][pAskQ], 128, params);

        InfoMsg(playerid, "Kamu telah mengirim pertanyaan ke penolong/admin online.");
    }
    else ErrorMsg(playerid, "Daftar permintaan sudah penuh.Harap tunggu sebentar.");
    return 1;
}
CMD:clearallasks(playerid, params[]) {

	if (!PlayerData[playerid][pLogged]) return ErrorMsg(playerid, "Kamu belum login.");

    if(pData[playerid][pAdmin] < 3)
            return PermissionError(playerid);
    
	if(!pData[playerid][pAdminDuty])
		return ErrorMsg(playerid, "Tidak bisa menggunakan perintah admin saat tidak bertugas");

    new
        count;

    for (new i = 0; i != MAX_ASK; i ++)
    {
        if(AskData[i][askExists]) {
            Ask_Remove(i);
            count++;
        }
    }
    if(!count)
        return ErrorMsg(playerid, "There are no active asks to display.");
            
    SendAdminMessage(COLOR_LENZ,"[AdmCmd] "WHITE_E" %s telah menghapus semua asks di server.",ReturnName(playerid));
    return 1;
}
stock AnswerQuestion(playerid, params[])
{
	static
        userid,
        text[128];

	if(sscanf(params, "us[128]", userid, text)) return SendSyntaxMessage(playerid, "/ans [playerid/PartOfName] [message]");

	if(userid == INVALID_PLAYER_ID) return ErrorMsg(playerid, "Kamu telah menentukan pemain yang tidak valid.");
    if(!PlayerData[userid][pAsk]) return ErrorMsg(playerid, "This player don't ask anything");

    SendClientMessageEx(userid, COLOR_LENZ, "[ANS] "YELLOW"%s", PlayerData[userid][pAskQ]);
    SendClientMessageEx(userid, COLOR_LENZ, "[Answer From %s] "YELLOW"%s", pData[playerid][pAdminname], text);
    SendStaffMessage(COLOR_LENZ,"[AdmCmd]"YELLOW" %s answered %s questions: %s", pData[playerid][pAdminname], ReturnName(userid), text);

    PlayerData[userid][pAsk] = false;
    PlayerData[userid][pAskQ] = EOS;
	//PlayerData[playerid][pAskPoint] ++;
    Ask_Clear(userid);
	return 1;
}
stock DisplayASKS(playerid)
{
	if(!Ask_Count()) return ErrorMsg(playerid, "There are no one ask active.");

    new
        dialog[900],
        text[128];

    format(dialog, sizeof(dialog),"ID\tIssuer\tQuestion\n");
    for (new i = 0; i != MAX_ASK; i ++) if(AskData[i][askExists]) {
        strunpack(text, AskData[i][askQuestion]);

        if(strlen(text) > 32)
            format(dialog, sizeof(dialog), "%s%d\t%s (%d)\t%.32s ...\n", dialog, i, ReturnName(AskData[i][askPlayer]), AskData[i][askPlayer], text);
        else
            format(dialog, sizeof(dialog), "%s%d\t%s (%d)\t%s\n", dialog, i, ReturnName(AskData[i][askPlayer]), AskData[i][askPlayer], text);
    }
    Dialog_Show(playerid, DialogAsks, DIALOG_STYLE_TABLIST_HEADERS,"Asks", dialog,"Pilih","Batalkan");
	return 1;
}

CMD:asks(playerid, params[]) {

	if (!PlayerData[playerid][pLogged]) return ErrorMsg(playerid, "Kamu belum login.");

    if(pData[playerid][pAdmin] < 1)
   		if(pData[playerid][pHelper] == 0)
     		return PermissionError(playerid);
	
	//if(pData[playerid][pAdminDuty] == 0)
		//return ErrorMsg(playerid, "Tidak bisa menggunakan perintah admin saat tidak bertugas");
    DisplayASKS(playerid);
    return 1;
}
Dialog:DialogAsks(playerid, response, listitem, inputtext[]) {
    if (response) {
        new string[225];

		new
            i = strval(inputtext),
            text[128],
            header[25];
        
        strunpack(text, AskData[i][askQuestion]);
        format(header, sizeof(header), ""YELLOW"Ask Id: #%d", i);
        format(string,sizeof(string),""WHITE_E"Issuer: "YELLOW"%s\n"WHITE_E"Question: "YELLOW"%s.", ReturnName(AskData[i][askPlayer]), text);
        SetPVarInt(playerid, "holdingAskPlayer", AskData[i][askPlayer]);
        Dialog_Show(playerid, DialogAns, DIALOG_STYLE_INPUT,header,string,"Jawab","Kembali");
    }
    return 1;
}

Dialog:DialogAns(playerid, response, listitem, inputtext[]) {
    if (response) {
        new issuerid = GetPVarInt(playerid, "holdingAskPlayer");

        if (!isnull(inputtext)) {
            new params[128];
            format(params, sizeof(params), "%d %s", issuerid, inputtext);
            AnswerQuestion(playerid, params);
        }
    } else DisplayASKS(playerid), DeletePVar(playerid, "holdingAskPlayer");
    return 1;
}