#define MAX_RACE 	10
#define MAX_RACE_CP	30

new RaceMaker[MAX_PLAYERS];
new RaceJoin[MAX_PLAYERS];
new RaceStep[MAX_PLAYERS];

enum E_RACE_STRUCT
{
	bool:raceStarted,
	raceCountdown,
	racePlayer,
	racePlayerFinished,
	Float: raceX[MAX_RACE_CP],
	Float: raceY[MAX_RACE_CP],
	Float: raceZ[MAX_RACE_CP]
}

new RaceData[MAX_RACE][E_RACE_STRUCT];

ResetRaceData(rid)
{
	RaceData[rid][raceStarted] = false;
	RaceData[rid][raceCountdown] = 3;
	RaceData[rid][racePlayer] = 1;
	RaceData[rid][racePlayerFinished] = 0;
	for (new i; i < MAX_RACE_CP; i ++)
	{
		RaceData[rid][raceX][i] = 0.0;
		RaceData[rid][raceY][i] = 0.0;
		RaceData[rid][raceZ][i] = 0.0;
	}
	foreach(new i : Player) if (RaceJoin[i] == rid)
	{
		RaceMaker[i] = -1;
		RaceJoin[i] = -1;
		RaceStep[i] = 0;
		DisablePlayerRaceCheckpoint(i);
	}
}

PlayerLeaveRace(playerid)
{
	new rid;
	if ((rid = RaceJoin[playerid]) != -1)
	{
		if (RaceMaker[playerid] == rid)
		{
			ResetRaceData(rid);
			SendMessageToRace(rid, "Race has cancelled because creator has disconnected.");
		}
		else if (RaceData[rid][raceStarted])
		{
			new str[68];
			format(str, sizeof(str), "%s has leave the race", ReturnName(playerid));
			SendMessageToRace(rid, str);
			RaceData[rid][racePlayerFinished]++;
			if (RaceData[rid][racePlayer] >= RaceData[rid][racePlayerFinished])
			{
				SendMessageToRace(rid, "Race has finished, you can create it again by {ffc191}/makerace.");
				ResetRaceData(rid);
			}			
		}
		else
		{
			new str[68];
			format(str, sizeof(str), "%s has leave the race", ReturnName(playerid));
			SendMessageToRace(rid, str);
			RaceData[rid][racePlayer]--;
			RaceJoin[playerid] = -1;
		}
	}
	return 1;
}

GetFreeRace()
{
	new count = 0;
	foreach(new i : Player) if (RaceMaker[i] != -1)
	{
		count++;
	}
	return count;
}

GetFreeRaceCP(rid)
{
	for (new i; i < MAX_RACE_CP; i ++)
	{
		if (!RaceData[rid][raceX][i] && !RaceData[rid][raceY][i] && !RaceData[rid][raceZ][i])
			return i;
	}
	return -1;
}

NextPlayerRace(playerid)
{
	new rid = RaceJoin[playerid], 
		step = RaceStep[playerid],
		next_step = ++RaceStep[playerid];

	if (!RaceData[rid][raceX][step] && !RaceData[rid][raceY][step] && !RaceData[rid][raceZ][step])
	{
		new str[68];

		DisablePlayerRaceCheckpoint(playerid);
		format(str, sizeof(str), "%s has finished!", ReturnName(playerid));
		SendMessageToRace(rid, str);
		RaceData[rid][racePlayerFinished]++;
		if (RaceData[rid][racePlayerFinished] >= RaceData[rid][racePlayer])
		{
			SendMessageToRace(rid, "Race has finished, you can create it again by {ffc191}/balap.");
			ResetRaceData(rid);
		}	
	}
	else if (!RaceData[rid][raceX][next_step] && !RaceData[rid][raceY][next_step] && !RaceData[rid][raceZ][next_step])
	{
		SetPlayerRaceCheckpoint(playerid, true, RaceData[rid][raceX][step], RaceData[rid][raceY][step], RaceData[rid][raceZ][step], 0.0,0.0,0.0, 3.0);
	}
	else
	{
		SetPlayerRaceCheckpoint(playerid, false, RaceData[rid][raceX][step], RaceData[rid][raceY][step], RaceData[rid][raceZ][step], RaceData[rid][raceX][next_step], RaceData[rid][raceY][next_step], RaceData[rid][raceZ][next_step], 3.0);
	}
	return 1;
}

SendMessageToRace(rid, message[])
{
	foreach(new i : Player)
	{
		if (RaceJoin[i] != rid) continue;

		SendClientMessageEx(i, COLOR_LENZ, "[BALAPAN]: {ffffff}%s", message);
	}
	return 1;
}

CMD:balap(playerid, params[])
{
	if (RaceMaker[playerid] != -1)
		return Error(playerid, "Anda sudah membuat race, gunakan {ffc191}/racecp{ffffff} untuk menambahkan checkpoint.");

	if (RaceJoin[playerid] != -1)
		return Error(playerid, "Anda sudah bergabung dalam race, gunakan {ffc191}/leaverace{ffffff} untuk keluar dari race.");

	new rid = GetFreeRace();
	if (rid >= MAX_RACE)
		return Error(playerid, "Batas membuat race di kota sudah mencapai limit!");

	ResetRaceData(rid);
	RaceMaker[playerid] = rid; 
	RaceJoin[playerid] = rid;
	Info(playerid, "Anda telah membuat race, gunakan {ffc191}/racecp{ffffff} untuk mengatur cekpoint.");
	foreach(new ii : Player)
	{
		if(pData[ii][pTogLog] == 0)
		{
			SendClientMessageEx(ii, COLOR_LENZ, "{ffc191}[BALAPAN] {ffffff}Seseorang telah membuat balapan.");
		}
	}
	return 1;
}

CMD:racecp(playerid, params[])
{
	new rid = RaceMaker[playerid],
		rcpid = GetFreeRaceCP(rid);
		
	if (rid == -1)
		return Error(playerid, "Ada belum membuat race!");

	if (rcpid == -1)
		return Error(playerid, "Cekpoint sudah mencapai batas (max: %d)", MAX_RACE_CP);

	GetPlayerPos(playerid, RaceData[rid][raceX][rcpid], RaceData[rid][raceY][rcpid], RaceData[rid][raceZ][rcpid]);
	Info(playerid, "Checkpoint ke-{ffc191}(%d/30){ffffff} berhasil ditambahkan", rcpid + 1);
	return 1;
}

CMD:gasbalap(playerid, params[])
{
	return Race_Start(playerid);
}

Race_Start(playerid)
{
	new rid = RaceMaker[playerid];
	if (rid == -1)
		return Error(playerid, "Ada belum membuat race!");

	if (RaceData[rid][raceStarted])
		return Error(playerid, "Race sudah dimulai!");

	if (RaceData[rid][racePlayer] < 2)
		return Error(playerid, "Minimal 2 player untuk memulai race!");

	SetTimerEx("RaceCountdownn", 1000, false, "i", rid);
	return 1;
}

CMD:keluarbalap(playerid, params[])
{
	return PlayerLeaveRace(playerid);
}

function RaceCountdownn(rid)
{
	new count = RaceData[rid][raceCountdown];
	RaceData[rid][raceCountdown]--;
	foreach(new i : Player)
	{
		if (RaceJoin[i] == rid)
		{
			if (count == 0) 
			{
				GameTextForPlayer(i, "~w~GO ~g~!~y~!~r~!", 1000, 6);
				TogglePlayerControllable(i, true);
				NextPlayerRace(i);
			}
			else if (count == 1)
			{
				GameTextForPlayer(i, "~g~1", 1000, 6);
			}
			else if (count == 2)
			{
				GameTextForPlayer(i, "~y~2", 1000, 6);
			}
			else if (count == 3)
			{
				TogglePlayerControllable(i, false);
				GameTextForPlayer(i, "~r~3", 1000, 6);
			}
		}
	}
	if (count > 0) SetTimerEx("RaceCountdownn", 1000, false, "i", rid);
}

CMD:invitebalap(playerid, params[])
{
	new rid = RaceMaker[playerid];
	if (rid == -1)
		return Error(playerid, "Ada belum membuat race!");

	new to_player;
    if(sscanf(params, "u", to_player))
        return Usage(playerid, "/invitebalap [playerid/PartOfName]");

    if(to_player == playerid)
    	return Error(playerid, "Anda tidak dapat memasukkan id sendiri!");

	if(!NearPlayer(playerid, to_player, 6.0))
		return Error(playerid, "Pemainnya terlalu jauh");

	if (RaceJoin[to_player] != -1)
		return Error(playerid, "Pemain ini sudah bergabung ke dalam race!");

	RaceJoin[to_player] = rid;
	RaceData[rid][racePlayer]++;
	Info(playerid, "Anda mengajak %s untuk bergabung ke race Anda!", ReturnName(to_player));
	Info(to_player, "%s mengajak Anda untuk bergabung ke racenya, Gunakan {ffc191}/keluarbalap{ffffff} untuk menolak!", ReturnName(to_player));
	return 1;
}
