new NearestItems[MAX_PLAYERS][MAX_LISTED_ITEMS];
enum droppedItems
{
	droppedID,
	droppedItem[32],
	droppedPlayer[24],
	droppedModel,
	droppedQuantity,
	Float:droppedPos[3],
	droppedWeapon,
	droppedAmmo,
	droppedInt,
	droppedWorld,
	droppedObject,
	STREAMER_TAG_3D_TEXT_LABEL:droppedText3D
};

new DroppedItems[MAX_DROPPED_ITEMS][droppedItems];

stock Item_Delete(itemid)
{
    new
	    query[64];

    if (itemid != -1 && DroppedItems[itemid][droppedModel])
	{
        DroppedItems[itemid][droppedModel] = 0;
		DroppedItems[itemid][droppedQuantity] = 0;
	    DroppedItems[itemid][droppedPos][0] = 0.0;
	    DroppedItems[itemid][droppedPos][1] = 0.0;
	    DroppedItems[itemid][droppedPos][2] = 0.0;
	    DroppedItems[itemid][droppedInt] = 0;
	    DroppedItems[itemid][droppedWorld] = 0;

	    DestroyDynamicObject(DroppedItems[itemid][droppedObject]);
	    DestroyDynamic3DTextLabel(DroppedItems[itemid][droppedText3D]);

	    mysql_format(g_SQL, query, sizeof(query), "DELETE FROM `dropped` WHERE `ID` = '%d'", DroppedItems[itemid][droppedID]);
	    mysql_tquery(g_SQL, query);
	}
	return 1;
}

stock Item_Nearest(playerid)
{
    for (new i = 0; i != MAX_DROPPED_ITEMS; i ++) if (DroppedItems[i][droppedModel] && IsPlayerInRangeOfPoint(playerid, 1.5, DroppedItems[i][droppedPos][0], DroppedItems[i][droppedPos][1], DroppedItems[i][droppedPos][2]))
	{
	    if (GetPlayerInterior(playerid) == DroppedItems[i][droppedInt] && GetPlayerVirtualWorld(playerid) == DroppedItems[i][droppedWorld])
	        return i;
	}
	return -1;
}

FUNC::Dropped_Load()
{
	new rows = cache_num_rows();
 	if(rows)
  	{
    	forex(i, rows)
		{
		    cache_get_value_name_int(i, "ID", DroppedItems[i][droppedID]);

			cache_get_value_name(i, "itemName", DroppedItems[i][droppedItem]);
			cache_get_value_name(i, "itemPlayer", DroppedItems[i][droppedPlayer]);

			cache_get_value_name_int(i, "itemModel", DroppedItems[i][droppedModel]);
			cache_get_value_name_int(i, "itemQuantity", DroppedItems[i][droppedQuantity]);
			cache_get_value_name_float(i, "itemX", DroppedItems[i][droppedPos][0]);
			cache_get_value_name_float(i, "itemY", DroppedItems[i][droppedPos][1]);
			cache_get_value_name_float(i, "itemZ", DroppedItems[i][droppedPos][2]);
			cache_get_value_name_int(i, "itemInt", DroppedItems[i][droppedInt]);
			cache_get_value_name_int(i, "itemWorld", DroppedItems[i][droppedWorld]);

			DroppedItems[i][droppedObject] = CreateDynamicObject(DroppedItems[i][droppedModel], DroppedItems[i][droppedPos][0], DroppedItems[i][droppedPos][1], DroppedItems[i][droppedPos][2], 0.0, 0.0, 0.0, DroppedItems[i][droppedWorld], DroppedItems[i][droppedInt]);
			
			new strings[150];
			format(strings, sizeof(strings), "[%s]\n{FFFFFF}Jumlah : %d", DroppedItems[i][droppedItem], DroppedItems[i][droppedQuantity]);
			DroppedItems[i][droppedText3D] = CreateDynamic3DTextLabel(strings, COLOR_DAVID, DroppedItems[i][droppedPos][0], DroppedItems[i][droppedPos][1], DroppedItems[i][droppedPos][2], 15.0, INVALID_PLAYER_ID, INVALID_VEHICLE_ID, 0, DroppedItems[i][droppedWorld], DroppedItems[i][droppedInt]);
		}
		printf("[DROPITEM] Loaded %d Dropped items from database.", rows);
	}
	return 1;
}

DropItem(item[], player[], model, quantity, Float:x, Float:y, Float:z, interior, world, weaponid = 0, ammo = 0)
{
	new
	    query[300];

	forex(i, MAX_DROPPED_ITEMS) if (!DroppedItems[i][droppedModel])
	{
	    format(DroppedItems[i][droppedItem], 32, item);
	    format(DroppedItems[i][droppedPlayer], 24, player);

		DroppedItems[i][droppedModel] = model;
		DroppedItems[i][droppedQuantity] = quantity;
		DroppedItems[i][droppedWeapon] = weaponid;
  		DroppedItems[i][droppedAmmo] = ammo;
		DroppedItems[i][droppedPos][0] = x;
		DroppedItems[i][droppedPos][1] = y;
		DroppedItems[i][droppedPos][2] = z;

		DroppedItems[i][droppedInt] = interior;
		DroppedItems[i][droppedWorld] = world;

		DroppedItems[i][droppedObject] = CreateDynamicObject(model, x, y, z, 0.0, 0.0, 0.0, world, interior);
		new strings[150];
		format(strings, sizeof(strings), "[%s]\n{FFFFFF}Jumlah : %d", item, quantity);
 		DroppedItems[i][droppedText3D] = CreateDynamic3DTextLabel(strings, COLOR_DAVID, x, y, z, 10.0, INVALID_PLAYER_ID, INVALID_VEHICLE_ID, 0, world, interior);

 		format(query, sizeof(query), "INSERT INTO `dropped` (`itemName`, `itemPlayer`, `itemModel`, `itemQuantity`, `itemWeapon`, `itemAmmo`, `itemX`, `itemY`, `itemZ`, `itemInt`, `itemWorld`) VALUES('%s', '%s', '%d', '%d', '%d', '%d', '%.4f', '%.4f', '%.4f', '%d', '%d')", item, player, model, quantity, weaponid, ammo, x, y, z, interior, world);
		mysql_tquery(g_SQL, query, "OnDroppedItem", "d", i);
		return i;
	}
	return -1;
}

FUNC::OnDroppedItem(itemid)
{
	if (itemid == -1 || !DroppedItems[itemid][droppedModel])
	    return 0;

	DroppedItems[itemid][droppedID] = cache_insert_id();
	return 1;
}
stock PickupItem(playerid, itemid)
{
	static
		string[32],
		str[32];
	if (itemid != -1 && DroppedItems[itemid][droppedModel])
	{
		if (itemid == -1)
			return 0;
		//new jumlahdrop = DroppedItems[itemid][droppedQuantity];
		strunpack(string, DroppedItems[itemid][droppedItem]);

		for (new i = 0; i < sizeof(g_aInventoryItems); i ++) if (!strcmp(g_aInventoryItems[i][e_InventoryItem], string, true))
		{

			if(DroppedItems[itemid][droppedModel] == 19564)
			{
				format(str, sizeof(str), "Add_%dx", DroppedItems[itemid][droppedQuantity]);
				ShowItemBox(playerid, string, str, DroppedItems[itemid][droppedModel], 2);

				pData[playerid][pSprunk] += DroppedItems[itemid][droppedQuantity];
				Item_Delete(itemid);
			}
			else if(DroppedItems[itemid][droppedModel] == 19562)
			{
				format(str, sizeof(str), "Add_%dx", DroppedItems[itemid][droppedQuantity]);
				ShowItemBox(playerid, string, str, DroppedItems[itemid][droppedModel], 2);

				pData[playerid][pSnack] += DroppedItems[itemid][droppedQuantity];
				Item_Delete(itemid);
			}
			else if(DroppedItems[itemid][droppedModel] == 1578)
			{
				format(str, sizeof(str), "Add_%dx", DroppedItems[itemid][droppedQuantity]);
				ShowItemBox(playerid, string, str, DroppedItems[itemid][droppedModel], 2);

				pData[playerid][pMarijuana] += DroppedItems[itemid][droppedQuantity];
				Item_Delete(itemid);
			}
			else if(DroppedItems[itemid][droppedModel] == 1577)
			{
				format(str, sizeof(str), "Add_%dx", DroppedItems[itemid][droppedQuantity]);
				ShowItemBox(playerid, string, str, DroppedItems[itemid][droppedModel], 2);

				pData[playerid][pObat] += DroppedItems[itemid][droppedQuantity];
				Item_Delete(itemid);
			}
			else if(DroppedItems[itemid][droppedModel] == 1579)
			{
				format(str, sizeof(str), "Add_%dx", DroppedItems[itemid][droppedQuantity]);
				ShowItemBox(playerid, string, str, DroppedItems[itemid][droppedModel], 2);

				pData[playerid][pMedicine] += DroppedItems[itemid][droppedQuantity];
				Item_Delete(itemid);
			}
			else if(DroppedItems[itemid][droppedModel] == 1650)
			{
				format(str, sizeof(str), "Add_%dx", DroppedItems[itemid][droppedQuantity]);
				ShowItemBox(playerid, string, str, DroppedItems[itemid][droppedModel], 2);

				pData[playerid][pGas] += DroppedItems[itemid][droppedQuantity];
				Item_Delete(itemid);
			}
			else if(DroppedItems[itemid][droppedModel] == 11736)
			{
				format(str, sizeof(str), "Add_%dx", DroppedItems[itemid][droppedQuantity]);
				ShowItemBox(playerid, string, str, DroppedItems[itemid][droppedModel], 2);

				pData[playerid][pBandage] += DroppedItems[itemid][droppedQuantity];
				Item_Delete(itemid);
			}
		}
	}
	return 1;
}
//else if (InventoryData[playerid][itemid][invTotalQuantity] == 1)
forward OnPlayerDropItem(playerid, itemid, name[]);
public OnPlayerDropItem(playerid, itemid, name[])
{
	static
		string[32],
		str[512];

	//new value = pData[playerid][pGiveAmount];

	if (itemid != -1 && InventoryData[playerid][itemid][invModel])
	{
		if (itemid == -1)
			return 0;
		//new jumlahdrop = InventoryData[playerid][itemid][invAmount];

		strunpack(string, InventoryData[playerid][itemid][invItem]);

		for (new i = 0; i < sizeof(g_aInventoryItems); i ++) if (!strcmp(g_aInventoryItems[i][e_InventoryItem], string, true))
		{

			if(InventoryData[playerid][itemid][invModel] == 2840)
			{
				if(GetNearbyTrash(playerid) >= 0)
				{
					for(new a = 0; a < MAX_Trash; a++)
					{
						if(IsPlayerInRangeOfPoint(playerid, 2.3, TrashData[a][TrashX], TrashData[a][TrashY], TrashData[a][TrashZ]))
						{
							if(TrashData[a][Sampah] > 299) return ErrorMsg(playerid, "Sampah penuh!");
							if(pData[playerid][sampahsaya] < 1) return 1;
							new total = pData[playerid][sampahsaya];
							pData[playerid][sampahsaya] -= total;
							format(str, sizeof(str), "Removed_%dx", total);
							ShowItemBox(playerid, "Sampah", str, 2840, total);
							Inventory_Close(playerid);
							Inventory_Update(playerid);
							TrashData[a][Sampah] += total;
							new query[128];
							mysql_format(g_SQL, query, sizeof(query), "UPDATE trash SET sampah='%d' WHERE ID='%d'", TrashData[a][Sampah], a);
							mysql_tquery(g_SQL, query);
							//StartPlayerLoadingBar(playerid, 1, "Membuang...");
							ShowProgressbar(playerid, "Membuang..", 2);
							ApplyAnimation(playerid,"GRENADE","WEAPON_throwu",4.0, 1, 0, 0, 0, 0, 1);
							Trash_Save(a);
							if(IsValidDynamic3DTextLabel(TrashData[a][TrashLabel]))
							DestroyDynamic3DTextLabel(TrashData[a][TrashLabel]);
							format(str, sizeof(str), "[ID : %d]{ffffff}Trash Capacity %d/300\n{ffffff}Tekan {ffc191}[ Y ] {ffffff}Untuk Membuang Sampah\nGunakan {ffc191}[ /findtrash ] {ffffff} untuk memungut sampah", a, TrashData[a][Sampah]);
							TrashData[a][TrashLabel] = CreateDynamic3DTextLabel(str, COLOR_DAVID, TrashData[a][TrashX], TrashData[a][TrashY], TrashData[a][TrashZ]+1.0, 10.0, INVALID_PLAYER_ID, INVALID_VEHICLE_ID, 1, TrashData[a][TrashWorld], TrashData[a][TrashInt], -1, 10.0);
						}
					}
				}
			}
			if(InventoryData[playerid][itemid][invModel] == 19564)
			{
				new
					Float:x,
					Float:y,
					Float:z,
					Float:angle;

				GetPlayerPos(playerid, x, y, z);
				GetPlayerFacingAngle(playerid, angle);

				DropItem(string, ReturnName(playerid), InventoryData[playerid][itemid][invModel], 1, x, y, z - 0.9, GetPlayerInterior(playerid), GetPlayerVirtualWorld(playerid));

				ApplyAnimation(playerid, "CARRY", "putdwn05", 4.1, 0, 1, 1, 0, 0, 1);

				pData[playerid][pSprunk] -= 1;

				format(str, sizeof(str), "> %s Telah membuang sprunk.", GetRPName(playerid));
				SetPlayerChatBubble(playerid, str, COLOR_PURPLE, 30.0, 10000);
				format(str, sizeof(str), "Remove_%dx", 1);
				ShowItemBox(playerid, "Sprunk", str, 19564, 2);
				Inventory_Close(playerid);
				Inventory_Update(playerid);
			}
			if(InventoryData[playerid][itemid][invModel] == 19562)
			{
				new
					Float:x,
					Float:y,
					Float:z,
					Float:angle;

				GetPlayerPos(playerid, x, y, z);
				GetPlayerFacingAngle(playerid, angle);

				DropItem(string, ReturnName(playerid), InventoryData[playerid][itemid][invModel], 1, x, y, z - 0.9, GetPlayerInterior(playerid), GetPlayerVirtualWorld(playerid));

				ApplyAnimation(playerid, "CARRY", "putdwn05", 4.1, 0, 1, 1, 0, 0, 1);

				pData[playerid][pSnack] -= 1;

				format(str, sizeof(str), "> %s Telah membuang Snack.", GetRPName(playerid));
				SetPlayerChatBubble(playerid, str, COLOR_PURPLE, 30.0, 10000);
				format(str, sizeof(str), "Remove_%dx", 1);
				ShowItemBox(playerid, "Snack", str, 19562, 2);
				Inventory_Close(playerid);
				Inventory_Update(playerid);
			}
			if(InventoryData[playerid][itemid][invModel] == 1578)
			{
				new
					Float:x,
					Float:y,
					Float:z,
					Float:angle;

				GetPlayerPos(playerid, x, y, z);
				GetPlayerFacingAngle(playerid, angle);

				DropItem(string, ReturnName(playerid), InventoryData[playerid][itemid][invModel], 1, x, y, z - 0.9, GetPlayerInterior(playerid), GetPlayerVirtualWorld(playerid));

				ApplyAnimation(playerid, "CARRY", "putdwn05", 4.1, 0, 1, 1, 0, 0, 1);

				pData[playerid][pMarijuana] -= 1;

				format(str, sizeof(str), "> %s Telah membuang marijuana.", GetRPName(playerid));
				SetPlayerChatBubble(playerid, str, COLOR_PURPLE, 30.0, 10000);
				format(str, sizeof(str), "Remove_%dx", 1);
				ShowItemBox(playerid, "Marijuana", str, 1578, 2);
				Inventory_Close(playerid);
				Inventory_Update(playerid);
			}
			if(InventoryData[playerid][itemid][invModel] == 1650)
			{
				new
					Float:x,
					Float:y,
					Float:z,
					Float:angle;

				GetPlayerPos(playerid, x, y, z);
				GetPlayerFacingAngle(playerid, angle);

				DropItem(string, ReturnName(playerid), InventoryData[playerid][itemid][invModel], 1, x, y, z - 0.9, GetPlayerInterior(playerid), GetPlayerVirtualWorld(playerid));

				ApplyAnimation(playerid, "CARRY", "putdwn05", 4.1, 0, 1, 1, 0, 0, 1);

				pData[playerid][pGas] -= 1;

				format(str, sizeof(str), "> %s Telah membuang jerigen.", GetRPName(playerid));
				SetPlayerChatBubble(playerid, str, COLOR_PURPLE, 30.0, 10000);
				format(str, sizeof(str), "Remove_%dx", 1);
				ShowItemBox(playerid, "Jerigen", str, 1650, 2);
				Inventory_Close(playerid);
				Inventory_Update(playerid);
			}
			if(InventoryData[playerid][itemid][invModel] == 1212)
			{
				ErrorMsg(playerid, "Item Ini Tidak Dapat Dibuang");
			}
			if(InventoryData[playerid][itemid][invModel] == 1575)
			{
				ErrorMsg(playerid, "Item Ini Tidak Dapat Dibuang");
			}
			if(InventoryData[playerid][itemid][invModel] == 1581)
			{
				ErrorMsg(playerid, "Item Ini Tidak Dapat Dibuang");
			}
			if(InventoryData[playerid][itemid][invModel] == 19627)
			{
				ErrorMsg(playerid, "Item Ini Tidak Dapat Dibuang");
			}
			if(InventoryData[playerid][itemid][invModel] == 11736)
			{
				new
					Float:x,
					Float:y,
					Float:z,
					Float:angle;

				GetPlayerPos(playerid, x, y, z);
				GetPlayerFacingAngle(playerid, angle);

				DropItem(string, ReturnName(playerid), InventoryData[playerid][itemid][invModel], 1, x, y, z - 0.9, GetPlayerInterior(playerid), GetPlayerVirtualWorld(playerid));

				ApplyAnimation(playerid, "CARRY", "putdwn05", 4.1, 0, 1, 1, 0, 0, 1);

				pData[playerid][pBandage] -= 1;

				format(str, sizeof(str), "> %s Telah membuang perban.", GetRPName(playerid));
				SetPlayerChatBubble(playerid, str, COLOR_PURPLE, 30.0, 10000);
				format(str, sizeof(str), "Remove_%dx", 1);
				ShowItemBox(playerid, "Perban", str, 11736, 2);
				Inventory_Close(playerid);
				Inventory_Update(playerid);
			}
			if(InventoryData[playerid][itemid][invModel] == 1577)
			{
				new
					Float:x,
					Float:y,
					Float:z,
					Float:angle;

				GetPlayerPos(playerid, x, y, z);
				GetPlayerFacingAngle(playerid, angle);

				DropItem(string, ReturnName(playerid), InventoryData[playerid][itemid][invModel], 1, x, y, z - 0.9, GetPlayerInterior(playerid), GetPlayerVirtualWorld(playerid));

				ApplyAnimation(playerid, "CARRY", "putdwn05", 4.1, 0, 1, 1, 0, 0, 1);

				pData[playerid][pObat] -= 1;

				format(str, sizeof(str), "> %s Telah membuang obat.", GetRPName(playerid));
				SetPlayerChatBubble(playerid, str, COLOR_PURPLE, 30.0, 10000);
				format(str, sizeof(str), "Remove_%dx", 1);
				ShowItemBox(playerid, "Obat", str, 1577, 2);
				Inventory_Close(playerid);
				Inventory_Update(playerid);
			}
			if(InventoryData[playerid][itemid][invModel] == 1579)
			{
				new
					Float:x,
					Float:y,
					Float:z,
					Float:angle;

				GetPlayerPos(playerid, x, y, z);
				GetPlayerFacingAngle(playerid, angle);

				DropItem(string, ReturnName(playerid), InventoryData[playerid][itemid][invModel], 1, x, y, z - 0.9, GetPlayerInterior(playerid), GetPlayerVirtualWorld(playerid));

				ApplyAnimation(playerid, "CARRY", "putdwn05", 4.1, 0, 1, 1, 0, 0, 1);

				pData[playerid][pMedicine] -= 1;

				format(str, sizeof(str), "> %s Telah membuang medicine.", GetRPName(playerid));
				SetPlayerChatBubble(playerid, str, COLOR_PURPLE, 30.0, 10000);
				format(str, sizeof(str), "Remove_%dx", 1);
				ShowItemBox(playerid, "Medicine", str, 1579, 2);
				Inventory_Close(playerid);
				Inventory_Update(playerid);
			}
		}
	}
	return 1;
}