# y_groups

Provides an abstraction for various collections of players; including factions, teams, admin levels, and more.  Allows for a single consistent interface, with support in many other YSI libraries allowing for permissions to be set on a per-group level for most features.

## YSI

For general YSI information, see the following links:

* [Installation](../installation.md)
* [Troubleshooting](../troubleshooting.md)

## Documentation

* [Quick Start](y_groups/quick-start.md) - One very simple example of getting started with this library.
* [Features](y_groups/features.md) - More features and examples.
* [FAQs](y_groups/faqs.md) - Frequently Asked Questions, including errors and solutions.
* [API](y_groups/api.md) - Full list of all functions and their meaning.
* [Internal](y_groups/internal.md) - Internal developer documentation for the system.

## External Links

These are links to external documentation and tutorials; both first- and third-party.  Note that these may be incomplete, obsolete, or otherwise inaccurate.

