# y_commands

The most fully featured command processor for SA:MP.  Includes:

* Full internationalisation - type commands in any language.
* Native permissions support, dynamically change who can use a command at any time with no code required within the command.
* y_groups support to further extend the permissions system to teams etc.
* Integrated help, so that each command can easilly have its help text defined along side its code.
* Multiple other checks for hidden/disabled/errored commands.
* Change the command prefix from `/`.
* `OnPlayerCommandReceived` and `OnPlayerCommandPerformed`.
* Rename commands at a per-player level (e.g. to have the same command in multiple languages).
* Alternate names for the same command.
* Multi-script (filterscript) support.
* `Command()` and `PlayerCommand()` Iterators to use with `foreach`.

## YSI

For general YSI information, see the following links:

* [Installation](../installation.md)
* [Troubleshooting](../troubleshooting.md)

## Documentation

* [Quick Start](y_commands/quick-start.md) - One very simple example of getting started with this library.
* [Features](y_commands/features.md) - More features and examples.
* [FAQs](y_commands/faqs.md) - Frequently Asked Questions, including errors and solutions.
* [API](y_commands/api.md) - Full list of all functions and their meaning.
* [Internal](y_commands/internal.md) - Internal developer documentation for the system.

## External Links

These are links to external documentation and tutorials; both first- and third-party.  Note that these may be incomplete, obsolete, or otherwise inaccurate.

